Index: squid/scripts/access-log-matrix.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/access-log-matrix.pl,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/scripts/access-log-matrix.pl	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/scripts/access-log-matrix.pl	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -47,9 +47,9 @@
 
 print  '       HOSTNAME: '. `hostname`;
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdat) = localtime($first);
-printf "FIRST LOG ENTRY: %s/%s/%s %.2d:%.2d:%.2d\n", $year,$mon+1,$mday, $hour,$min,$sec;
+printf "FIRST LOG ENTRY: %04d/%02d/%02d %.2d:%.2d:%.2d\n", $year+1900,$mon+1,$mday, $hour,$min,$sec;
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdat) = localtime($last);
-printf " LAST LOG ENTRY: %s/%s/%s %.2d:%.2d:%.2d\n", $year,$mon+1,$mday, $hour,$min,$sec;
+printf " LAST LOG ENTRY: %04d/%02d/%02d %.2d:%.2d:%.2d\n", $year+1900,$mon+1,$mday, $hour,$min,$sec;
 print "\n";
 
 printf ("%25.25s %5s %5s %5s %5s %5s %5s %5s %5s\n",
Index: squid/snmplib/snmp_vars.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/snmplib/snmp_vars.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/snmplib/snmp_vars.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/snmplib/snmp_vars.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
@@ -115,7 +115,8 @@
     printf("VARS: Creating.\n");
 #endif
 
-    New = (struct variable_list *) xmalloc(sizeof(struct variable_list));
+    New = xmalloc(sizeof(*New));
+    /* XXX xmalloc never returns NULL */
     if (New == NULL) {
 	snmp_set_api_error(SNMPERR_OS_ERR);
 	return (NULL);
@@ -131,6 +132,7 @@
 	return (New);
     }
     New->name = (oid *) xmalloc(Len * sizeof(oid));
+    /* XXX xmalloc never returns NULL */
     if (New->name == NULL) {
 	xfree(New);
 	snmp_set_api_error(SNMPERR_OS_ERR);
@@ -147,6 +149,17 @@
     return (New);
 }
 
+struct variable_list *
+snmp_var_new_integer(oid * Name, int Len, int ival, unsigned char type)
+{
+    variable_list *v = snmp_var_new(Name, Len);
+    v->val_len = sizeof(int);
+    v->val.integer = xmalloc(sizeof(int));
+    v->type = type;
+    *(v->val.integer) = ival;
+    return v;
+}
+
 /* Clone a variable list.
  *
  * Returns NULL upon error.
@@ -214,7 +227,7 @@
 
 /* Free a variable_list.
  */
-void 
+void
 snmp_var_free(struct variable_list *Ptr)
 {
     if (Ptr->name && Ptr->name_length > 0)
Index: squid/src/HttpHdrCc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHdrCc.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHdrCc.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHdrCc.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHdrCc.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHdrCc.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 65    HTTP Cache Control Header
  * AUTHOR: Alex Rousskov
@@ -47,6 +47,7 @@
     {"proxy-revalidate", CC_PROXY_REVALIDATE},
     {"only-if-cached", CC_ONLY_IF_CACHED},
     {"max-age", CC_MAX_AGE},
+    {"s-maxage", CC_S_MAXAGE},
     {"Other,", CC_OTHER}	/* ',' will protect from matches */
 };
 HttpHeaderFieldInfo *CcFieldsInfo = NULL;
@@ -58,13 +59,13 @@
 /* module initialization */
 
 void
-httpHdrCcInitModule()
+httpHdrCcInitModule(void)
 {
     CcFieldsInfo = httpHeaderBuildFieldsInfo(CcAttrs, CC_ENUM_END);
 }
 
 void
-httpHdrCcCleanModule()
+httpHdrCcCleanModule(void)
 {
     httpHeaderDestroyFieldsInfo(CcFieldsInfo, CC_ENUM_END);
     CcFieldsInfo = NULL;
@@ -73,10 +74,10 @@
 /* implementation */
 
 HttpHdrCc *
-httpHdrCcCreate()
+httpHdrCcCreate(void)
 {
     HttpHdrCc *cc = memAllocate(MEM_HTTP_HDR_CC);
-    cc->max_age = -1;
+    cc->max_age = cc->s_maxage = -1;
     return cc;
 }
 
@@ -132,6 +133,13 @@
 		EBIT_CLR(cc->mask, type);
 	    }
 	    break;
+	case CC_S_MAXAGE:
+	    if (!p || !httpHeaderParseInt(p, &cc->s_maxage)) {
+		debug(65, 2) ("cc: invalid s-maxage specs near '%s'\n", item);
+		cc->s_maxage = -1;
+		EBIT_CLR(cc->mask, type);
+	    }
+	    break;
 	default:
 	    /* note that we ignore most of '=' specs */
 	    break;
@@ -155,6 +163,7 @@
     dup = httpHdrCcCreate();
     dup->mask = cc->mask;
     dup->max_age = cc->max_age;
+    dup->s_maxage = cc->s_maxage;
     return dup;
 }
 
@@ -165,11 +174,18 @@
     int pcount = 0;
     assert(cc && p);
     for (flag = 0; flag < CC_ENUM_END; flag++) {
-	if (flag == CC_MAX_AGE && cc->max_age >= 0) {
-	    packerPrintf(p, "max-age=%d", (int) cc->max_age);
-	    pcount++;
-	} else if (EBIT_TEST(cc->mask, flag) && flag != CC_OTHER) {
+	if (EBIT_TEST(cc->mask, flag) && flag != CC_OTHER) {
+
+	    /* print option name */
 	    packerPrintf(p, (pcount ? ", %s" : "%s"), strBuf(CcFieldsInfo[flag].name));
+
+	    /* handle options with values */
+	    if (flag == CC_MAX_AGE)
+		packerPrintf(p, "=%d", (int) cc->max_age);
+
+	    if (flag == CC_S_MAXAGE)
+		packerPrintf(p, "=%d", (int) cc->s_maxage);
+
 	    pcount++;
 	}
     }
@@ -181,6 +197,8 @@
     assert(cc && new_cc);
     if (cc->max_age < 0)
 	cc->max_age = new_cc->max_age;
+    if (cc->s_maxage < 0)
+	cc->s_maxage = new_cc->s_maxage;
     cc->mask |= new_cc->mask;
 }
 
@@ -196,6 +214,18 @@
 	EBIT_CLR(cc->mask, CC_MAX_AGE);
 }
 
+/* negative s_maxage will clean old s-maxage setting */
+void
+httpHdrCcSetSMaxAge(HttpHdrCc * cc, int s_maxage)
+{
+    assert(cc);
+    cc->s_maxage = s_maxage;
+    if (s_maxage >= 0)
+	EBIT_SET(cc->mask, CC_S_MAXAGE);
+    else
+	EBIT_CLR(cc->mask, CC_S_MAXAGE);
+}
+
 void
 httpHdrCcUpdateStats(const HttpHdrCc * cc, StatHist * hist)
 {
Index: squid/src/HttpHdrContRange.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHdrContRange.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHdrContRange.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHdrContRange.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHdrContRange.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHdrContRange.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 68    HTTP Content-Range Header
  * AUTHOR: Alex Rousskov
@@ -81,7 +81,7 @@
     p++;
     /* do we have last-pos ? */
     if (p - field < flen) {
-	size_t last_pos;
+	ssize_t last_pos;
 	if (!httpHeaderParseSize(p, &last_pos))
 	    return 0;
 	spec->length = size_diff(last_pos + 1, spec->offset);
@@ -110,7 +110,7 @@
  */
 
 HttpHdrContRange *
-httpHdrContRangeCreate()
+httpHdrContRangeCreate(void)
 {
     HttpHdrContRange *r = memAllocate(MEM_HTTP_HDR_CONTENT_RANGE);
     r->spec.offset = r->spec.length = range_spec_unknown;
@@ -187,7 +187,7 @@
 }
 
 void
-httpHdrContRangeSet(HttpHdrContRange * cr, HttpHdrRangeSpec spec, size_t ent_len)
+httpHdrContRangeSet(HttpHdrContRange * cr, HttpHdrRangeSpec spec, ssize_t ent_len)
 {
     assert(cr && ent_len >= 0);
     cr->spec = spec;
Index: squid/src/HttpHdrExtField.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHdrExtField.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHdrExtField.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHdrExtField.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHdrExtField.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHdrExtField.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 69    HTTP Header: Extension Field
  * AUTHOR: Alex Rousskov
Index: squid/src/HttpHdrRange.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHdrRange.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHdrRange.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHdrRange.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHdrRange.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHdrRange.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 64    HTTP Range Header
  * AUTHOR: Alex Rousskov
@@ -55,7 +55,7 @@
 
 
 /* local constants */
-#define range_spec_unknown ((size_t)-1)
+#define range_spec_unknown ((ssize_t)-1)
 
 /* local routines */
 #define known_spec(s) ((s) != range_spec_unknown)
@@ -73,7 +73,7 @@
  */
 
 static HttpHdrRangeSpec *
-httpHdrRangeSpecCreate()
+httpHdrRangeSpecCreate(void)
 {
     return memAllocate(MEM_HTTP_HDR_RANGE_SPEC);
 }
@@ -102,7 +102,7 @@
 	p++;
 	/* do we have last-pos ? */
 	if (p - field < flen) {
-	    size_t last_pos;
+	    ssize_t last_pos;
 	    if (!httpHeaderParseSize(p, &last_pos))
 		return NULL;
 	    spec.length = size_diff(last_pos + 1, spec.offset);
@@ -209,7 +209,7 @@
  */
 
 HttpHdrRange *
-httpHdrRangeCreate()
+httpHdrRangeCreate(void)
 {
     HttpHdrRange *r = memAllocate(MEM_HTTP_HDR_RANGE);
     stackInit(&r->specs);
@@ -303,7 +303,7 @@
  *   - there is at least one range spec
  */
 int
-httpHdrRangeCanonize(HttpHdrRange * range, size_t clen)
+httpHdrRangeCanonize(HttpHdrRange * range, ssize_t clen)
 {
     int i;
     HttpHdrRangeSpec *spec;
@@ -386,8 +386,10 @@
     return 0;
 }
 
-/* hack: returns true if range specs may be too "complex" when "canonized" */
-/* see also: httpHdrRangeIsComplex */
+/*
+ * hack: returns true if range specs may be too "complex" when "canonized".
+ * see also: httpHdrRangeIsComplex.
+ */
 int
 httpHdrRangeWillBeComplex(const HttpHdrRange * range)
 {
@@ -409,12 +411,14 @@
     return 0;
 }
 
-/* Returns lowest known offset in range spec(s), or range_spec_unknown */
-/* this is used for size limiting */
-size_t
+/*
+ * Returns lowest known offset in range spec(s), or range_spec_unknown
+ * this is used for size limiting
+ */
+ssize_t
 httpHdrRangeFirstOffset(const HttpHdrRange * range)
 {
-    size_t offset = range_spec_unknown;
+    ssize_t offset = range_spec_unknown;
     HttpHdrRangePos pos = HttpHdrRangeInitPos;
     const HttpHdrRangeSpec *spec;
     assert(range);
@@ -425,16 +429,17 @@
     return offset;
 }
 
-/* Returns lowest offset in range spec(s), 0 if unknown */
-/* This is used for finding out where we need to start if all
+/*
+ * Returns lowest offset in range spec(s), 0 if unknown.
+ * This is used for finding out where we need to start if all
  * ranges are combined into one, for example FTP REST.
  * Use 0 for size if unknown
  */
-size_t
-httpHdrRangeLowestOffset(const HttpHdrRange * range, size_t size)
+ssize_t
+httpHdrRangeLowestOffset(const HttpHdrRange * range, ssize_t size)
 {
-    size_t offset = range_spec_unknown;
-    size_t current;
+    ssize_t offset = range_spec_unknown;
+    ssize_t current;
     HttpHdrRangePos pos = HttpHdrRangeInitPos;
     const HttpHdrRangeSpec *spec;
     assert(range);
Index: squid/src/HttpHeader.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHeader.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHeader.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHeader.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHeader.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHeader.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 55    HTTP Header
  * AUTHOR: Alex Rousskov
@@ -141,6 +141,7 @@
     HDR_CONNECTION,
     HDR_IF_MATCH, HDR_IF_NONE_MATCH,
     HDR_LINK, HDR_PRAGMA,
+    HDR_PROXY_CONNECTION,
     /* HDR_TRANSFER_ENCODING, */
     HDR_UPGRADE,
     HDR_VARY,
@@ -227,7 +228,7 @@
  */
 
 void
-httpHeaderInitModule()
+httpHeaderInitModule(void)
 {
     int i;
     /* check that we have enough space for masks */
@@ -264,7 +265,7 @@
 }
 
 void
-httpHeaderCleanModule()
+httpHeaderCleanModule(void)
 {
     httpHeaderDestroyFieldsInfo(Headers, HDR_ENUM_END);
     Headers = NULL;
@@ -383,7 +384,16 @@
     HttpHeaderStats[hdr->owner].parsedCount++;
     /* commonn format headers are "<name>:[ws]<value>" lines delimited by <CRLF> */
     while (field_start < header_end) {
-	const char *field_end = field_start + strcspn(field_start, "\r\n");
+	const char *field_end;
+	const char *field_ptr = field_start;
+	do {
+	    field_end = field_ptr = field_ptr + strcspn(field_ptr, "\r\n");
+	    /* skip CRLF */
+	    if (*field_ptr == '\r')
+		field_ptr++;
+	    if (*field_ptr == '\n')
+		field_ptr++;
+	} while (*field_ptr == ' ' || *field_ptr == '\t');
 	if (!*field_end || field_end > header_end)
 	    return httpHeaderReset(hdr);	/* missing <CRLF> */
 	e = httpHeaderEntryParseCreate(field_start, field_end);
Index: squid/src/HttpHeaderTools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHeaderTools.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpHeaderTools.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpHeaderTools.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHeaderTools.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpHeaderTools.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 66    HTTP Header Tools
  * AUTHOR: Alex Rousskov
@@ -97,17 +97,18 @@
 }
 
 /* same as httpHeaderPutStr, but formats the string using snprintf first */
-#if STDC_HEADERS
 void
+#if STDC_HEADERS
 httpHeaderPutStrf(HttpHeader * hdr, http_hdr_type id, const char *fmt,...)
-{
-    va_list args;
-    va_start(args, fmt);
 #else
-void
 httpHeaderPutStrf(va_alist)
      va_dcl
+#endif
 {
+#if STDC_HEADERS
+    va_list args;
+    va_start(args, fmt);
+#else
     va_list args;
     HttpHeader *hdr = NULL;
     http_hdr_type id = HDR_ENUM_END;
@@ -135,7 +136,7 @@
 
 /* wrapper arrounf PutContRange */
 void
-httpHeaderAddContRange(HttpHeader * hdr, HttpHdrRangeSpec spec, size_t ent_len)
+httpHeaderAddContRange(HttpHeader * hdr, HttpHdrRangeSpec spec, ssize_t ent_len)
 {
     HttpHdrContRange *cr = httpHdrContRangeCreate();
     assert(hdr && ent_len >= 0);
@@ -146,23 +147,28 @@
 
 
 /*
- * return true if a given directive is found in at least one of the "connection" header-fields
- * note: if HDR_PROXY_CONNECTION is present we ignore HDR_CONNECTION
+ * return true if a given directive is found in at least one of
+ * the "connection" header-fields note: if HDR_PROXY_CONNECTION is
+ * present we ignore HDR_CONNECTION.
  */
 int
 httpHeaderHasConnDir(const HttpHeader * hdr, const char *directive)
 {
-    if (httpHeaderHas(hdr, HDR_PROXY_CONNECTION)) {
-	const char *str = httpHeaderGetStr(hdr, HDR_PROXY_CONNECTION);
-	return str && !strcasecmp(str, directive);
-    }
-    if (httpHeaderHas(hdr, HDR_CONNECTION)) {
-	String str = httpHeaderGetList(hdr, HDR_CONNECTION);
-	const int res = strListIsMember(&str, directive, ',');
-	stringClean(&str);
-	return res;
-    }
-    return 0;
+    String list;
+    http_hdr_type ht;
+    int res;
+    /* what type of header do we have? */
+    if (httpHeaderHas(hdr, HDR_PROXY_CONNECTION))
+	ht = HDR_PROXY_CONNECTION;
+    else if (httpHeaderHas(hdr, HDR_CONNECTION))
+	ht = HDR_CONNECTION;
+    else
+	return 0;
+
+    list = httpHeaderGetList(hdr, ht);
+    res = strListIsMember(&list, directive, ',');
+    stringClean(&list);
+    return res;
 }
 
 /* returns true iff "m" is a member of the list */
@@ -171,9 +177,12 @@
 {
     const char *pos = NULL;
     const char *item;
+    int ilen = 0;
+    int mlen;
     assert(list && m);
-    while (strListGetItem(list, del, &item, NULL, &pos)) {
-	if (!strcasecmp(item, m))
+    mlen = strlen(m);
+    while (strListGetItem(list, del, &item, &ilen, &pos)) {
+	if (mlen == ilen && !strncasecmp(item, m, ilen))
 	    return 1;
     }
     return 0;
@@ -183,6 +192,18 @@
 int
 strListIsSubstr(const String * list, const char *s, char del)
 {
+    assert(list && del);
+    return strStr(*list, s) != 0;
+
+    /*
+     * Note: the original code with a loop is broken because it uses strstr()
+     * instead of strnstr(). If 's' contains a 'del', strListIsSubstr() may
+     * return true when it should not. If 's' does not contain a 'del', the
+     * implementaion is equavalent to strstr()! Thus, we replace the loop with
+     * strstr() above until strnstr() is available.
+     */
+
+#ifdef BROKEN_CODE
     const char *pos = NULL;
     const char *item;
     assert(list && s);
@@ -191,6 +212,7 @@
 	    return 1;
     }
     return 0;
+#endif
 }
 
 /* appends an item to the list */
@@ -276,7 +298,7 @@
 }
 
 int
-httpHeaderParseSize(const char *start, size_t * value)
+httpHeaderParseSize(const char *start, ssize_t * value)
 {
     int v;
     const int res = httpHeaderParseInt(start, &v);
@@ -366,5 +388,6 @@
 	if (c2)
 	    len2++;
     }
+    /* NOTREACHED */
     return 0;
 }
Index: squid/src/HttpReply.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpReply.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpReply.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpReply.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpReply.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpReply.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 58    HTTP Reply (Response)
  * AUTHOR: Alex Rousskov
@@ -60,7 +60,7 @@
 
 /* module initialization */
 void
-httpReplyInitModule()
+httpReplyInitModule(void)
 {
     httpHeaderMaskInit(&Denied304HeadersMask, 0);
     httpHeaderCalcMask(&Denied304HeadersMask, (const int *) Denied304HeadersArr, countof(Denied304HeadersArr));
@@ -68,7 +68,7 @@
 
 
 HttpReply *
-httpReplyCreate()
+httpReplyCreate(void)
 {
     HttpReply *rep = memAllocate(MEM_HTTP_REPLY);
     debug(58, 7) ("creating rep: %p\n", rep);
@@ -125,21 +125,31 @@
     httpReplyDoDestroy(new_rep);
 }
 
-/* parses a 4K buffer that may not be 0-terminated; returns true on success */
+/*
+ * httpReplyParse takes character buffer of HTTP headers (buf),
+ * which may not be NULL-terminated, and fills in an HttpReply
+ * structure (rep).  The parameter 'end' specifies the offset to
+ * the end of the reply headers.  The caller may know where the
+ * end is, but is unable to NULL-terminate the buffer.  This function
+ * returns true on success.
+ */
 int
-httpReplyParse(HttpReply * rep, const char *buf)
+httpReplyParse(HttpReply * rep, const char *buf, ssize_t end)
 {
     /*
-     * this extra buffer/copy will be eliminated when headers become meta-data
-     * in store. Currently we have to xstrncpy the buffer becuase store.c may
-     * feed a non 0-terminated buffer to us.
+     * this extra buffer/copy will be eliminated when headers become
+     * meta-data in store. Currently we have to xstrncpy the buffer
+     * becuase somebody may feed a non NULL-terminated buffer to
+     * us.
      */
     char *headers = memAllocate(MEM_4K_BUF);
     int success;
     /* reset current state, because we are not used in incremental fashion */
     httpReplyReset(rep);
-    /* put a 0-terminator */
+    /* put a string terminator */
     xstrncpy(headers, buf, 4096);
+    if (end >= 0 && end < 4096)
+	*(headers + end) = '\0';
     success = httpReplyParseStep(rep, headers, 0);
     memFree(headers, MEM_4K_BUF);
     return success == 1;
@@ -301,8 +311,10 @@
     rep->content_range = httpHeaderGetContRange(hdr);
     rep->keep_alive = httpMsgIsPersistent(rep->sline.version, &rep->header);
     /* final adjustments */
-    /* The max-age directive takes priority over Expires, check it first */
-    if (rep->cache_control && rep->cache_control->max_age >= 0)
+    /* The s-maxage and max-age directive takes priority over Expires */
+    if (rep->cache_control && rep->cache_control->s_maxage >= 0)
+	rep->expires = squid_curtime + rep->cache_control->s_maxage;
+    else if (rep->cache_control && rep->cache_control->max_age >= 0)
 	rep->expires = squid_curtime + rep->cache_control->max_age;
     else
 	/*
@@ -401,3 +413,22 @@
     *parse_start = *blk_end;
     return 1;
 }
+
+/*
+ * Returns the body size of a HTTP response
+ */
+int
+httpReplyBodySize(method_t method, HttpReply * reply)
+{
+    if (METHOD_HEAD == method)
+	return 0;
+    else if (reply->sline.status == HTTP_OK)
+	(void) 0;		/* common case, continue */
+    else if (reply->sline.status == HTTP_NO_CONTENT)
+	return 0;
+    else if (reply->sline.status == HTTP_NOT_MODIFIED)
+	return 0;
+    else if (reply->sline.status < HTTP_OK)
+	return 0;
+    return reply->content_length;
+}
Index: squid/src/HttpRequest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpRequest.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpRequest.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpRequest.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpRequest.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpRequest.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 73    HTTP Request
  * AUTHOR: Duane Wessels
@@ -44,6 +44,9 @@
     if (urlpath)
 	stringReset(&req->urlpath, urlpath);
     req->max_forwards = -1;
+    req->lastmod = -1;
+    req->client_addr = no_addr;
+    req->my_addr = no_addr;
     httpHeaderInit(&req->header, hoRequest);
     return req;
 }
@@ -151,3 +154,13 @@
 	return 0;
     return 1;
 }
+
+/* returns true if header is allowed to be passed on */
+int
+httpRequestHdrAllowedByName(http_hdr_type id)
+{
+    /* check with anonymizer tables */
+    if (CBIT_TEST(Config.anonymize_headers, id))
+	return 0;
+    return 1;
+}
Index: squid/src/HttpStatusLine.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpStatusLine.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/HttpStatusLine.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/HttpStatusLine.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpStatusLine.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: HttpStatusLine.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 57    HTTP Status-line
  * AUTHOR: Alex Rousskov
Index: squid/src/MemPool.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/MemPool.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/MemPool.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/MemPool.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: MemPool.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: MemPool.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 63    Low Level Memory Pool Management
  * AUTHOR: Alex Rousskov
@@ -55,9 +55,9 @@
 static Stack Pools;
 
 /* local prototypes */
-static void memShrink(size_t new_limit);
+static void memShrink(ssize_t new_limit);
 static void memPoolDescribe(const MemPool * pool);
-static void memPoolShrink(MemPool * pool, size_t new_limit);
+static void memPoolShrink(MemPool * pool, ssize_t new_limit);
 
 
 
@@ -132,9 +132,9 @@
 
 
 static void
-memShrink(size_t new_limit)
+memShrink(ssize_t new_limit)
 {
-    size_t start_limit = TheMeter.idle.level;
+    ssize_t start_limit = TheMeter.idle.level;
     int i;
     assert(start_limit >= 0 && new_limit >= 0);
     debug(63, 1) ("memShrink: started with %d KB goal: %d KB\n",
@@ -142,7 +142,7 @@
     /* first phase: cut proportionally to the pool idle size */
     for (i = 0; i < Pools.count && TheMeter.idle.level > new_limit; ++i) {
 	MemPool *pool = Pools.items[i];
-	const size_t target_pool_size = (size_t) ((double) pool->meter.idle.level * new_limit) / start_limit;
+	const ssize_t target_pool_size = (size_t) ((double) pool->meter.idle.level * new_limit) / start_limit;
 	memPoolShrink(pool, target_pool_size);
     }
     debug(63, 1) ("memShrink: 1st phase done with %d KB left\n", toKB(TheMeter.idle.level));
@@ -266,7 +266,7 @@
 }
 
 static void
-memPoolShrink(MemPool * pool, size_t new_limit)
+memPoolShrink(MemPool * pool, ssize_t new_limit)
 {
     assert(pool);
     assert(new_limit >= 0);
Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/access_log.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/access_log.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: access_log.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: access_log.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
@@ -135,28 +135,44 @@
      * more readable.
      */
     while ((c = *(const unsigned char *) header++) != '\0') {
-	if (c <= 0x1F
-	    || c >= 0x7F
-	    || c == '"'
-	    || c == '#'
-	    || c == '%'
-	    || c == ';'
-	    || c == '<'
-	    || c == '>'
-	    || c == '?'
-	    || c == '{'
-	    || c == '}'
-	    || c == '|'
-	    || c == '\\'
-	    || c == '^'
-	    || c == '~'
-	    || c == '`'
-	    || c == '['
+#if !OLD_LOG_MIME
+	if (c == '\r') {
+	    *buf_cursor++ = '\\';
+	    *buf_cursor++ = 'r';
+	} else if (c == '\n') {
+	    *buf_cursor++ = '\\';
+	    *buf_cursor++ = 'n';
+	} else
+#endif
+	    if (c <= 0x1F
+		|| c >= 0x7F
+#if OLD_LOG_MIME
+		|| c == '"'
+		|| c == '#'
+		|| c == '%'
+		|| c == ';'
+		|| c == '<'
+		|| c == '>'
+		|| c == '?'
+		|| c == '{'
+		|| c == '}'
+		|| c == '|'
+		|| c == '\\'
+		|| c == '^'
+		|| c == '~'
+		|| c == '`'
+#endif
+		|| c == '['
 	    || c == ']') {
 	    *buf_cursor++ = '%';
 	    i = c * 2;
 	    *buf_cursor++ = c2x[i];
 	    *buf_cursor++ = c2x[i + 1];
+#if !OLD_LOG_MIME
+	} else if (c == '\\') {
+	    *buf_cursor++ = '\\';
+	    *buf_cursor++ = '\\';
+#endif
 	} else {
 	    *buf_cursor++ = (char) c;
 	}
@@ -216,10 +232,23 @@
 {
     assert(fname);
     xstrncpy(LogfileName, fname, SQUID_MAXPATHLEN);
-    LogfileFD = file_open(LogfileName, O_WRONLY | O_CREAT, NULL, NULL, NULL);
+    LogfileFD = file_open(LogfileName, O_WRONLY | O_CREAT);
     if (LogfileFD == DISK_ERROR) {
-	debug(50, 0) ("%s: %s\n", LogfileName, xstrerror());
-	fatalf("Cannot open %s: %s", LogfileName, xstrerror());
+	if (ENOENT == errno) {
+	    fatalf("%s cannot be created, since the\n"
+		"\tdirectory it is to reside in does not exist."
+		"\t(%s)\n", LogfileName, xstrerror());
+	} else if (EACCES == errno) {
+	    fatalf("cannot create %s:\n"
+		"\t%s.\n"
+		"\tThe directory access.log is to reside in needs to be\n"
+		"\twriteable by the user %s, the cache_effective_user\n"
+		"\tset in squid.conf.",
+		LogfileName, xstrerror(), Config.effectiveUser);
+	} else {
+	    debug(50, 0) ("%s: %s\n", LogfileName, xstrerror());
+	    fatalf("Cannot open %s: %s", LogfileName, xstrerror());
+	}
     }
     LogfileStatus = LOG_ENABLE;
 }
@@ -314,16 +343,16 @@
 	i--;
 	snprintf(from, MAXPATHLEN, "%s.%d", fname, i - 1);
 	snprintf(to, MAXPATHLEN, "%s.%d", fname, i);
-	rename(from, to);
+	xrename(from, to);
     }
     /* Rotate the current log to .0 */
     file_close(LogfileFD);	/* always close */
     if (Config.Log.rotateNumber > 0) {
 	snprintf(to, MAXPATHLEN, "%s.%d", fname, 0);
-	rename(fname, to);
+	xrename(fname, to);
     }
     /* Reopen the log.  It may have been renamed "manually" */
-    LogfileFD = file_open(fname, O_WRONLY | O_CREAT, NULL, NULL, NULL);
+    LogfileFD = file_open(fname, O_WRONLY | O_CREAT);
     if (LogfileFD == DISK_ERROR) {
 	debug(46, 0) ("accessLogRotate: Cannot open logfile: %s\n", fname);
 	LogfileStatus = LOG_DISABLE;
@@ -371,7 +400,7 @@
 	    fatal("Cannot open Multicast Miss Stream Socket");
 	debug(46, 1) ("Multicast Miss Stream Socket opened on FD %d\n",
 	    mcast_miss_fd);
-	mcastSetTtl(mcast_miss_fd, 128);
+	mcastSetTtl(mcast_miss_fd, Config.mcast_miss.ttl);
 	if (strlen(Config.mcast_miss.encode_key) < 16)
 	    fatal("mcast_encode_key is too short, must be 16 characters");
     }
